(* Script to archive selected files/folders and name them 

History: 

2009-11-12, 12.10, hk: First version is working. 
2010-10-24,	18:35, hk:	Added check for finder frontmostness
2012-12-18,	20:56, h:	Mod for ASL.

ToDo:

-strip leading directories from archive, so that they don't get created when expanding...



*)

on run (argv)
	(*	tell application "System Events"
		set frontmostAppName to name of processes whose frontmost is true
		if frontmost of process "Finder" is false then
			tell application "Finder"
				activate
				display dialog "Please invoke the script only if Finder is in foreground. This time it was \"" & frontmostAppName & "\"!" buttons {"Ah, okay."}
			end tell
			return
		end if
	end tell
*)
	
	(* Archive! *)
	tell application "Finder"
		activate
		set selectedItems to selection
		if ((count of selectedItems) is 1) then
			#		else if ((count of selectedItems) is greater than 1) then
			set theItem to first item in selectedItems #as alias
			#get class of theItem
			set theItemClass to class of theItem
			log theItemClass
			set theItemName to name of theItem
			set theItemContainer to (container of theItem) as alias
			set itemPath to POSIX path of (theItem as alias)
			set itemContainerPath to POSIX path of theItemContainer
			if (theItemClass is folder) then (* not using type because it's localized, class is not *)
				(* remove trailing "/" *)
				set l to length of itemPath
				set itemPath to text 1 thru (l - 1) of itemPath
				log "shortened: " & itemPath
			else
				# mach nix 
			end if
			set zipFileName to theItemName & " " & my timestamp() & ".zip"
			#set zipFilePath to itemContainerPath & "" & theItemName & "_" & my timestamp() & ".zip"
			#trasht alle dirs im zip set cmd to "zip -j -r \"" & zipFilePath & "\" \"" & itemPath & "\"" # -m
			set cmd to "cd \"" & itemContainerPath & "\" && zip -r \"" & zipFileName & "\" \"" & theItemName & "\"" # -m
			#			set cmd to "zip \"" & zipFilePath & "\" -x .\\* \"" & itemPath & "\""
			log cmd
			do shell script cmd
		else
			display dialog "Please select one files/folders in Finder." buttons "Allright, I do whatever you say!"
		end if
	end tell
end run









(* get a time stamp *)
on timestamp()
	set dateNow to current date
	set dateYear to year of dateNow
	set dateMonth to addLeadingZeros(2, (month of dateNow as number) as string)
	set dateDay to addLeadingZeros(2, day of dateNow)
	set dateHour to addLeadingZeros(2, hours of dateNow)
	set dateMinute to addLeadingZeros(2, minutes of dateNow)
	set dateString to (dateYear & "-" & dateMonth & "-" & dateDay & " " & dateHour & "-" & dateMinute) as string
end timestamp

(* Liefert von einer Zahl n leading zeros zurck *)
on addLeadingZeros(zeroesCount, value)
	
	(* nimmt die letzten zeroesCount Stellen des Strings *)
	set newNumber to (text -zeroesCount thru -1 of ("0000000000000000" & value)) (* Da musch drauf kommen: http://macscripter.net/viewtopic.php?id=24533 *)
	log "newNumber: " & newNumber
	
	return (newNumber)
end addLeadingZeros

