#tell application "Finder" to set ptd to (path to desktop folder) as string

tell application "Mail"
	set theMessages to selection
	if ((count of theMessages) > 0) then
		try
			--tell AppleScript -- "Finder"
			tell application "Finder"
				activate
				set chosenFolder to choose folder with prompt "Choose folder to save messages in:"
			end tell (* Finder *)
			
			(* Save the messages *)
			repeat with theMessage in theMessages
				--mailbody		set theText to content of theMessage
				set theText to source of theMessage -- raw message (header & body)
				tell theMessage
					set theMessageSubject to subject
					set theMessageDateReceived to date received
					set theMessageDateSent to date sent
					#if ( 
					tell me to set theMessageDate to timestamp(theMessageDateReceived)
					set theFileName to "Foo.txt"
					set theFileName to theMessageDate & "_" & theMessageSubject & ".txt"
					tell me to set theFileName to replaceBadChars(theFileName, "_")
					#set theFileName to theMessageDate & ".txt"
				end tell (* theMessage *)
				
				(* this whole blocks throws errors in every command! although it works fine. *)
				tell application "Finder"
					set theFile to (chosenFolder as string) & theFileName #"Message Number " & (theMessage's id as string)
					set theFileID to open for access file theFile with write permission
					write theText to theFileID
					try
						close access theFileID # throws -10004 - WHY?
					on error (e)
						log "Error: " & e
					end try
				end tell
			end repeat
			
		on error (e)
			log "Error: " & e
		end try
		
	end if
	activate
end tell (* Mail *)





(* Method to replace bad chars in filename with a given string. *)
to replaceBadChars(stringToCheck, replacementString)
	set legalChars to {"A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "_", "-", "."} (* ([a-z],[A-Z],[0-9],\+, _,-,\.) *)
	
	set badChars to ""
	set res to ""
	repeat with ci from 1 to (count of stringToCheck)
		set c to item ci of stringToCheck
		log c
		
		set charIsLegal to false
		repeat with l from 1 to (count of legalChars)
			if (c is item l of legalChars) then
				set charIsLegal to true
				exit repeat
			end if
		end repeat
		
		(* Auswerten, ob der letzte Char OK war *)
		if (charIsLegal is true) then
			set res to res & c
		else
			set res to res & replacementString
			#set isBadString to true
			#set badChars to badChars & c
		end if
		
	end repeat
	
	#log {"Bad Chars: ", badChars}
	
	return res
	
end replaceBadChars


(* get a time stamp *)
on timestamp(givenDate)
	set dateYear to year of givenDate
	set dateMonth to addLeadingZeros(2, (month of givenDate as number))
	set dateDay to addLeadingZeros(2, day of givenDate)
	set dateHour to addLeadingZeros(2, hours of givenDate)
	set dateMinute to addLeadingZeros(2, minutes of givenDate)
	set dateString to (dateYear & "-" & dateMonth & "-" & dateDay & "_" & dateHour & "-" & dateMinute) as string
end timestamp

(* Liefert von einer Zahl n leading zeros zurck *)
on addLeadingZeros(zeroesCount, value)
	
	(* nimmt die letzten zeroesCount Stellen des Strings *)
	set newNumber to (text -zeroesCount thru -1 of ("0000000000000000" & value)) (* Da musch drauf kommen: http://macscripter.net/viewtopic.php?id=24533 *)
	log "newNumber: " & newNumber
	
	return (newNumber)
end addLeadingZeros
