on run (argv)
	
	(* Save old Clipboard Contents *)
	set oldClipboard to the clipboard
	
	(* Clear Clipboard *)
	set the clipboard to ""
	
	(* Get selected text *)
	tell application "System Events" to keystroke "c" using {command down}
	get clipboard info
	log (the clipboard)
	
	(* Get the Clipboard *)
	set someword to the clipboard
	log "someWord: " & someword
	#return
	if (oldClipboard is equal to someword) then
		log "Most likely you held some more modifiers down (f.e. if you launch this script with FastScripts and a Shortcut that uses option, control or shift..)"
		#		(* Trying to invoke "Copy" Menu command *)
		#		set appName to name of current application
		#		#	my menu_click({appName, my menuEditLocalized(), my menuItemEditCopyLocalized(), ""})
		#		tell application "System Events"
		#			set procs to every process
		#			repeat with p in procs
		#				if frontmost of p is true then
		#					set proc to p
		#				end if
		#			end repeat
		#			#set proc to items of processes whose frontmost is true
		#			#set proc to item 1 of processes
		#			get proc
		#			#click menu item "Copy" of ((proc)'s (menu bar 1)'s (menu bar item "Edit"))
		#			set menuBar to menu bar 1 of proc
		#			set editMenu to menu bar item whose name is (my menuEditLocalized())
		#			return 0
		#		end tell
	end if
	#delay 0.5
	
	(* Open Browser with query *)
	tell application "Safari"
		activate
		open location "http://dict.leo.org/?search='" & someword & "'"
	end tell
	
	(* Restore previous clipboard *)
	set the clipboard to oldClipboard
end run

(* get localized copy menu item name *)
on menuItemEditCopyLocalized()
	tell AppleScript
		set cmd to "defaults read NSGlobalDomain AppleLanguages | grep -v \"^(\" | grep -v \"^)\" | head -1 | cut -d, -f1 | awk '{printf $1}'"
		set languageCode to do shell script cmd
		if (languageCode is "de") then
			return "Kopieren"
		else if (languageCode is "en") then
			return "Copy"
		else
			log "WTF?"
			return ""
		end if
	end tell
end menuItemEditCopyLocalized


(* get localized copy menu name *)
on menuEditLocalized()
	tell AppleScript
		set cmd to "defaults read NSGlobalDomain AppleLanguages | grep -v \"^(\" | grep -v \"^)\" | head -1 | cut -d, -f1 | awk '{printf $1}'"
		set languageCode to do shell script cmd
		if (languageCode is "de") then
			return "Bearbeiten"
		else if (languageCode is "en") then
			return "Edit"
		else
			log "WTF?"
			return ""
		end if
	end tell
end menuEditLocalized




(* This came from http://www.macosxhints.com/article.php?story=20060921045743404 *)
on menu_click(mList)
	local appName, topMenu, r
	
	-- Validate our input
	if mList's length < 3 then error "Menu list is not long enough"
	
	-- Set these variables for clarity and brevity later on
	set {appName, topMenu} to (items 1 through 2 of mList)
	set r to (items 3 through (mList's length) of mList)
	
	-- This overly-long line calls the menu_recurse function with
	-- two arguments: r, and a reference to the top-level menu
	tell application "System Events" to my menu_click_recurse(r, ((process appName)'s 
		(menu bar 1)'s (menu bar item topMenu)'s (menu topMenu)))
end menu_click

on menu_click_recurse(mList, parentObject)
	local f, r
	
	-- `f` = first item, `r` = rest of items
	set f to item 1 of mList
	if mList's length > 1 then set r to (items 2 through (mList's length) of mList)
	
	-- either actually click the menu item, or recurse again
	tell application "System Events"
		if mList's length is 1 then
			click parentObject's menu item f
		else
			my menu_click_recurse(r, (parentObject's (menu item f)'s (menu f)))
		end if
	end tell
end menu_click_recurse