on run (argv)
	#log kennify("Gaga")
	
	if false then
	(* Save old Clipboard Contents *)
	my logToConsole("getting old clipboard contents...")
	set oldClipboard to the clipboard
	try
		my logToConsole("oldClipboard: " & oldClipboard)
	on error (e)
		my logToConsole("oldClipboard: was not loggable, maybe not TEXT?")
	end try
	
	(* Clear Clipboard *)
	set the clipboard to ""
	my logToConsole("emptied the clipboard.")
	
	(* Get selected text *)
	set someword to ""
	repeat 23 times
		(* Try to copy the selection to clipboard, might fail, if some more modifiers down (f.e. if you launch this script with FastScripts and a Shortcut that uses option, control or shift..) *)
		try
			tell application "System Events" to keystroke "c" using {command down}
			(* Try to copy the clipboard contents *)
			try
				set someword to the clipboard as text
			#	if (oldClipboard is not equal to someword and someword is not "") then
					exit repeat
			#	end if
			on error (e)
				my logToConsole("Error while copying selection to clipboard (cmd-c): " & e)
			end try
		on error (e)
			my logToConsole("Error while copying the clipboard: " & e)
		end try
		delay 0.1
	end repeat
end if
	
	(* If copying to and from clipboard worked *)
	if someword is not "" then
		(* String conversion *)
		tell me to set newWord to kennify(someword)
		log "newWord: " & newWord
		my logToConsole("newWord: " & newWord)
		set the clipboard to newWord
		set newClipboard to the clipboard
		my logToConsole("new clipboard content: " & newClipboard)
		
#		(* Paste it *)
#		tell application "System Events" to keystroke "v" using {command down}
	end if
	
#	(* Clipboard restore *)
#	delay 2 (* Essential - The cmd-V might not been fully executed at this time when we restore the clip! *)
#	set the clipboard to oldClipboard
end run


on kennify(givenString)
	set kennifiedString to ""
	(* Get the scripts' root path *)
	set pfad to path to me (* Might not work properly in AppleScript Editor, since it does not point to the script, but to AppleScript Editor... *)
	set posix_path to POSIX path of pfad
	tell me to logToConsole(posix_path)
	set textConversionFolderPath to my pathOfFilePath(posix_path)
	tell me to logToConsole(textConversionFolderPath)
	set scriptsFolderPath to my pathOfFilePath(textConversionFolderPath)
	tell me to logToConsole(scriptsFolderPath)
	(* Locate the helper script *)
	set pathToKenny to scriptsFolderPath & "/Zome More Tools/.Internals/Kenny/kenny.pl"
	(* Kennify *)
	set cmd to "echo \"" & givenString & "\" | \"" & pathToKenny & "\""
	try
		set kennifiedString to do shell script cmd
	on error (e)
		log e
	end try
	return kennifiedString
end kennify


on logToConsole(someText)
	tell AppleScript
		try
			set cmd to "logger -p daemon.notice \"" & "LHS: " & someText & "\""
			do shell script cmd
		on error (e)
			log e
		end try
	end tell
end logToConsole


on pathOfFilePath(fullPath)
	# http://developer.apple.com/documentation/applescript/conceptual/applescriptlangguide/index.html
	# http://macscripter.net/viewtopic.php?id=24525
	
	(* Text-Liste in echte Liste umwandeln *)
	set oldAST to AppleScript's text item delimiters
	set AppleScript's text item delimiters to "/"
	set elements to text items of fullPath
	
	set elememtsminuseins to items 1 thru ((count of items in elements) - 1) of elements
	
	set res to elememtsminuseins as text
	
	
	set AppleScript's text item delimiters to oldAST
	
	res
end pathOfFilePath