(* BTW: Error -25131 is badPasteboardIndexErr - item index does not exist
http://discussions.info.apple.com/thread.jspa?messageID=9962008
*)


(* Main *)
on run (argv)
	#delay 1
	my logToConsole("--")
	my logFrontMostProcess()
	
	#log my lowerCase("DOH!")
	
	if false then
		(* Save old Clipboard Contents *)
		my logToConsole("getting old clipboard contents...")
		set oldClipboard to the clipboard
		try
			my logToConsole("oldClipboard: " & oldClipboard)
		on error (e)
			my logToConsole("oldClipboard: was not loggable, maybe not TEXT?")
		end try
		
		(* Clear Clipboard *)
		set the clipboard to ""
		my logToConsole("emptied the clipboard.")
		
		(* Get selected text *)
		set someword to ""
		repeat 23 times
			(* Try to copy the selection to clipboard, might fail, if some more modifiers down (f.e. if you launch this script with FastScripts and a Shortcut that uses option, control or shift..) *)
			try
				tell application "System Events" to keystroke "c" using {command down}
				(* Try to copy the clipboard contents *)
				try
					set someword to the clipboard as text
					#if (oldClipboard is not equal to someword and someword is not "") then
					exit repeat
					#end if
				on error (e)
					my logToConsole("Error while copying selection to clipboard (cmd-c): " & e)
				end try
			on error (e)
				my logToConsole("Error while copying the clipboard: " & e)
			end try
			delay 0.1
		end repeat
	end if
	
	(* If copying to and from clipboard worked *)
	if someword is not "" then
		(* String conversion *)
		tell me to set newWord to lowerCase(someword)
		log "newWord: " & newWord
		my logToConsole("newWord: " & newWord)
		set the clipboard to newWord
		set newClipboard to the clipboard
		my logToConsole("new clipboard content: " & newClipboard)
		
		#		(* Paste it *)
		#		delay 1 (* Essential - The cmd-v might been executed BEFORE the clipboard is actually updated! *)
		#		tell application "System Events" to keystroke "v" using {command down}
	end if
	
	#	(* Clipboard restore *)
	#	delay 2 (* Essential - The cmd-V might not been fully executed at this time when we restore the clip! *)
	#	set the clipboard to oldClipboard
	
	my logFrontMostProcess()
end run

on logToConsole(someText)
	tell AppleScript
		try
			set cmd to "logger -p daemon.notice \"" & "LHS: " & someText & "\""
			do shell script cmd
		on error (e)
			log e
		end try
	end tell
end logToConsole

on logFrontMostProcess()
	(* Find the frontmost process *)
	tell application "System Events" to set fmps to (every process whose frontmost is true) -- and has scripting terminology is true)
	set fmp to first item in fmps
	
	(* Log name *)
	my logToConsole("Frontmost Process: " & name of fmp & " (" & short name of fmp & ")")
end logFrontMostProcess

to lowerCase(s)
	log "s: " & s
	log "len s: " & length of s
	set uc to "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	set lc to "abcdefghijklmnopqrstuvwxyz"
	repeat with i from 1 to 26
		set AppleScript's text item delimiters to character i of uc
		set s to text items of s
		set AppleScript's text item delimiters to character i of lc
		set s to s as text
	end repeat
	set AppleScript's text item delimiters to ""
	return s
end lowerCase
